package com.lutao.tcp.server;

import com.lutao.tcp.server.tcptest.BootNettyServer;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.scheduling.annotation.EnableAsync;

@SpringBootApplication
@EnableAsync
public class TcpServerApplication implements CommandLineRunner {

    public static void main(String[] args) {
        //SpringApplication.run(TcpServerApplication.class, args);
        new SpringApplication(TcpServerApplication.class).run(args);
        System.out.println("TcpServerApplication start");
    }

    @Override
    public void run(String... args) throws Exception {
        new BootNettyServer().bind(5635);
    }
}
