//package com.lutao.tcp.server.tcptest;
//
//import io.netty.buffer.ByteBuf;
//import io.netty.buffer.Unpooled;
//import io.netty.channel.ChannelHandlerContext;
//import io.netty.handler.codec.ByteToMessageDecoder;
//import io.netty.util.CharsetUtil;
//
//import java.util.List;
//
//public class Custom extends ByteToMessageDecoder {
//    private final ByteBuf delimiter;
//
//    public Custom() {
//        delimiter = Unpooled.copiedBuffer("\r\n".getBytes(CharsetUtil.UTF_8));
//    }
//
//    @Override
//    protected void decode(ChannelHandlerContext ctx, ByteBuf in, List<Object> out) throws Exception {
//        int delimiterLength = delimiter.readableBytes();
//        int index = indexOf(in, delimiter);
//
//        if (index >= 0) {
//            ByteBuf frame = in.readRetainedSlice(index - in.readerIndex());
//            in.skipBytes(delimiterLength);
//            out.add(frame);
//        }
//    }
//
//    private int indexOf(ByteBuf buffer, ByteBuf delimiter) {
//        for (int i = buffer.readerIndex(); i < buffer.writerIndex(); i++) {
//            int j = 0;
//            while (j < delimiter.capacity() && buffer.getByte(i + j) == delimiter.getByte(j)) {
//                j++;
//            }
//            if (j == delimiter.capacity()) {
//                return i;
//            }
//        }
//        return -1;
//    }
//
//    @Override
//    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) {
//        cause.printStackTrace();
//        ctx.close();
//    }
//}