//package com.lutao.tcp.server.tcptest;
//
//import io.netty.buffer.ByteBuf;
//import io.netty.buffer.Unpooled;
//import io.netty.channel.ChannelHandlerContext;
//import io.netty.handler.codec.ByteToMessageDecoder;
//import io.netty.util.CharsetUtil;
//
//import java.util.List;
//
//public class CustomDelimiterDecoder extends ByteToMessageDecoder {
//
//    private final ByteBuf delimiter;
//
//    public CustomDelimiterDecoder() {
//        delimiter = Unpooled.copiedBuffer("\r\n".getBytes(CharsetUtil.UTF_8));
//    }
//
//    @Override
//    protected void decode(ChannelHandlerContext ctx, ByteBuf in, List<Object> out) throws Exception {
//        int delimiterLength = delimiter.readableBytes();
//        int index = in.indexOf(in.readerIndex(), in.writerIndex(), delimiter.readByte());
//        if (index != -1) {
//            ByteBuf frame = in.readRetainedSlice(index - in.readerIndex());
//            in.skipBytes(delimiterLength); // 跳过分隔符
//            out.add(frame);
//        }
//    }
//
//    @Override
//    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) {
//        cause.printStackTrace();
//        ctx.close();
//    }
//}